/***********************************************************************/
/*                                                                     */
/*                                 GALAX                               */
/*                              XQuery Engine                          */
/*                                                                     */
/*  Copyright 2001-2003, Lucent Technologies.                          */
/*  Distributed only by permission.                                    */
/*                                                                     */
/***********************************************************************/

/* $Id: itemlist.h,v 1.3 2003/06/12 02:30:44 simeon Exp $ */

#ifdef GALAXCOMPILE
#include <caml/mlvalues.h>
#include <caml/callback.h>
#include <caml/memory.h>
#else
typedef long value;
#endif

typedef value *item;

typedef struct itemlist_elem {
  value *item; 
  struct itemlist_elem *next;
} *itemlist;

extern void item_free(item i);
extern void itemlist_free(itemlist il);

extern itemlist itemlist_empty();
extern itemlist itemlist_cons(item i, itemlist cdr);

/* Functions that we need: */
/* extern itemlist itemlist_append(itemlist i1, itemlist i2); */
/* extern itemlist itemlist_put(itemlist i1, item i); */

extern int is_empty(itemlist p);

extern item     items_first(itemlist p);
extern itemlist items_next(itemlist p);

itemlist itemlist_from_camllist(value l);
value    camllist_from_itemlist(itemlist items);


